#ifndef __IMAGEHANDLE_H__
#define __IMAGEHANDLE_H__

#include <string>
#include <gdal_priv.h>
#include <cv.h>

#include "OkanMisc.h"

using namespace std;

#define IM_READONLY 1

class ImageHandle {
  friend class MosaickerPanel;
  friend class OPGPanel;
  friend class ImageFactory;
  friend class ImageProcessor;
  friend class Dem;
  GDALDataset* dataset;
  string imagePath;
  unsigned char* rawData;
  unsigned char* origData;
  int width, height, bpp;
 public:
  ImageHandle();
  ~ImageHandle() {
    if(origData)
      delete[] origData;
    delete[] rawData;
    releaseImage();
  }
  int loadImage(string imagePath, int mode);
  int releaseImage();
  int getWidth();
  int getHeight();
  int getBpp();
  unsigned char* getOriginalRawData();
  int clonePhysical(string, string, ImageHandle**);
  unsigned char* copyOriginalRawData();
  unsigned char* copyRawImageData();
  void getRawData(unsigned char**, int*, Roi*);
  IplImage* getIplHandle();
  IplImage* getOrigIplHandle();
};
#endif
