#include "gdal_priv.h"
#include "initializers.h"

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/dom/DOM.hpp>
#include <xercesc/parsers/XercesDOMParser.hpp>
#include <xercesc/sax/HandlerBase.hpp>
#include <xercesc/util/XMLString.hpp>

#include <iostream>

#include "content.h"

using namespace std;

XERCES_CPP_NAMESPACE_USE

bool initXMLParser() {
	try {
		XMLPlatformUtils::Initialize();
	}
	catch (const XMLException& toCatch) {
		char* errorMessage = XMLString::transcode(toCatch.getMessage());
		cerr << "Error during the initialization of Xerces XML library!" << endl;
		cerr << "Error log starts here:" << endl << errorMessage << endl << "Error log ends here" << endl;
		XMLString::release(&errorMessage);
		return 0;
	}
	
	return true;
}

bool initGDAL() {
	GDALAllRegister();
	return true;
}

ContentType convertToContentType(string type) {
	ContentType stype;
	if(!stricmp(type.c_str(), "image"))
		stype = Image2D;
	else if(!stricmp(type.c_str(), "dem"))
		stype = DEM;
	else if(!stricmp(type.c_str(), "orthophoto"))
		stype = OrthophotoType;
	else if(!stricmp(type.c_str(), "mosaic"))
		stype = Mosaic;
	else if(!stricmp(type.c_str(), "superresolution"))
		stype = SuperResolution;
	else if(!stricmp(type.c_str(), "camera"))
	  stype = CameraType;
	else if(!stricmp(type.c_str(), "video"))
	  stype = VideoType;
	else
		stype = UnknownType;
	return stype;
}
