#ifndef __ITEMINFOPANE_H__
#define __ITEMINFOPANE_H__

#include "content.h"
#include "projectPresenter.h"

#include <wx/wx.h>

class ItemInfoPane : public wxPanel {
public:
  enum {
    IdName = wxID_HIGHEST + 1,
    IdComments,
    IdProjectAddress,
    IdImageAddress,
    IdNameText,
    IdCommentText,
    IdImagePathText,
    IdNotSelected,
    IdF,
    IdX,
    IdY,
    IdZ,
    IdPSize,
    IdKappa,
    IdOmega,
    IdPhi,
    IdPX,
    IdPY
  };
  Content* content;
  ProjectPresenter* project;
 private:
  wxBoxSizer *outSizer, *projectSizer, *imageSizer, *buttonSizer, *topSizer, *cameraSizer;

public:
  ItemInfoPane(wxWindow* parent, wxWindowID id = wxID_ANY, wxPoint pos = wxDefaultPosition, wxSize size = wxDefaultSize, long style = wxHSCROLL | wxVSCROLL);
  void setContent(Content* newContent) {
    content = newContent;
    project = NULL;
  }
  void setContent(ProjectPresenter* newProject) {
    project = newProject;
    content = NULL;
  }

  bool update(); 
  void hideSizers() {
    outSizer->Hide((size_t)0);
    outSizer->Hide((size_t)1);
    outSizer->Hide((size_t)2);
    outSizer->Hide((size_t)3);
    outSizer->Hide((size_t)4);
    outSizer->Hide((size_t)5);
    outSizer->Hide((size_t)6);
  }
};

#endif
