#include "newProjectDialogS2.h"

#include <vector>
#include <string>
#include <wx/wx.h>

using namespace std;

BEGIN_EVENT_TABLE(NewProjectDialogS2, wxDialog)
EVT_BUTTON(IdFilesCtrl, NewProjectDialogS2::onFilesButton)
END_EVENT_TABLE()

NewProjectDialogS2::NewProjectDialogS2() {
}

NewProjectDialogS2::NewProjectDialogS2(wxWindow* parent, wxWindowID id, wxString caption, wxPoint pos, wxSize size, long style) 
  : wxDialog(parent, id, caption, pos, size, style) {
  Create(parent, id, caption, pos, size, style) ;
}

void NewProjectDialogS2::Create(wxWindow* parent, wxWindowID id, wxString caption, wxPoint pos, wxSize size, long style)  {
  wxBoxSizer* outSizer = new wxBoxSizer(wxHORIZONTAL);
  SetSizer(outSizer);

  wxBoxSizer* topSizer = new wxBoxSizer(wxVERTICAL);
  outSizer->Add(topSizer, 0, wxALIGN_CENTER_HORIZONTAL | wxALL, 5);
  
  wxStaticText* fileListText = new wxStaticText(this, wxID_STATIC, _("Enter the name of files you wish to import to the project:"), wxDefaultPosition, wxDefaultSize, 0);
  topSizer->Add(fileListText, 0, wxALIGN_LEFT | wxALL, 5);
  
  fileListCtrl = new wxTextCtrl(this, IdFileListCtrl, _("files"), wxDefaultPosition, wxSize(GetSize().GetWidth() - 20, 100), wxTE_MULTILINE | wxTE_CHARWRAP);
  topSizer->Add(fileListCtrl, 0, wxALIGN_LEFT | wxALL, 5);

  wxBoxSizer* secSizer = new wxBoxSizer(wxHORIZONTAL);
  topSizer->Add(secSizer, 0, wxALIGN_LEFT | wxALL, 1);

  wxCheckBox* copyFilesCtrl = new wxCheckBox(this, IdCopyFilesCtrl, _("Create copies of files"), wxDefaultPosition, wxDefaultSize, 0);
  secSizer->Add(copyFilesCtrl, 0, wxALIGN_LEFT | wxALL, 5);
  
  wxButton* fdButton = new wxButton(this, IdFilesCtrl, _(""), wxDefaultPosition, wxSize(25, 25), 0);
  secSizer->Add(fdButton, 0, wxALIGN_RIGHT | wxALL, 3);

  wxBoxSizer* buttonSizer = new wxBoxSizer(wxHORIZONTAL);
  topSizer->Add(buttonSizer, 0, wxALIGN_RIGHT | wxALL, 5);
  
  wxButton* okButton = new wxButton(this, wxID_OK, _("&Import"), wxDefaultPosition, wxDefaultSize, 0);
  buttonSizer->Add(okButton, 0, wxALIGN_CENTER_VERTICAL | wxALL, 3);

  wxButton* cancelButton = new wxButton(this, wxID_CANCEL, _("&Cancel"), wxDefaultPosition, wxDefaultSize, 0);
  buttonSizer->Add(cancelButton, 0, wxALIGN_CENTER_VERTICAL | wxALL, 3);
}

void NewProjectDialogS2::onFilesButton(wxCommandEvent& evt) {
  wxArrayString fileList;
  int flSize;
  wxFileDialog* fd = new wxFileDialog(this, _("Select the files you wish to import"), _(""), _(""), _("*.*"), wxFD_OPEN | wxFD_MULTIPLE );
  if(fd->ShowModal() == wxID_OK) {
    fd->GetPaths(fileList);
    flSize = fileList.GetCount();
      for(unsigned int i = 0; i < flSize; i++) {
	(*fileListCtrl) << fileList[i] << _("\n"); 
      }
  }
}

bool NewProjectDialogS2::TransferDataFromWindow() {
  int nLines = fileListCtrl->GetNumberOfLines();
  for(unsigned int i = 0; i < nLines - 1; i++) {
    imageList.push_back((const char*)wxConvCurrent->cWX2MB(fileListCtrl->GetLineText(i)));
  }
  return true;
}
