#ifndef __ORTHOPHOTOPANEL_H__
#define __ORTHOPHOTOPANEL_H__

#include <iostream>

#include <wx/panel.h>
#include <wx/wx.h>
#include <wx/listctrl.h>

#ifdef LINUX
#include "../projectManager.h"
#elif WIN32
#include "projectManager.h"
#endif

#ifdef WIN32

#ifdef ORTHOPHOTOPLUGIN_EXPORTS
#define PLUGIN_API __declspec(dllexport)
#else
#define PLUGIN_API __declspec(dllimport)
#endif

#ifdef __cplusplus    // If used by C++ code, 
extern "C"          // we need to export the C interface
#endif
PLUGIN_API void __cdecl plugOPG(wxWindow*, ProjectManager* pm);

#ifdef __cplusplus    // If used by C++ code, 
extern "C"          // we need to export the C interface
#endif
PLUGIN_API wxSize __cdecl negotiateSize();

#elif LINUX

extern "C" void plugOPG(wxWindow*, ProjectManager* pm);
extern "C" wxSize negotiateSize();

#endif


using namespace std;

#define xsize 250
#define ysize 400

class OPGPanel : public wxPanel {
  protected:
  DECLARE_EVENT_TABLE()
  private:
  enum {
    IdStartCtrl = wxID_HIGHEST + 1,
    IdAvgHeight,
    IdSpecifyROI,
    IdUseDEMs,
    IdOutputAnaglyph
  };
  ProjectManager* pm;
  wxListCtrl* imListCtrl;
 public:
  //MosaickerWindow();
  OPGPanel(ProjectManager* pm, wxWindow* parent, wxWindowID id = wxID_ANY, wxPoint pos = wxDefaultPosition, wxSize size = wxSize(xsize, ysize), long style = wxTAB_TRAVERSAL);

  void Init();

  //bool Create(wxWindow*, wxWindowID, wxString, wxPoint, wxSize, long);

  void CreateControls();
  void onStartOPG(wxCommandEvent&);
};

#endif
