#include <iostream>
#include <algorithm>

#include "project.h"

using namespace std;

int Project::currentId = 0;
int Project::addContent(Content* newContent) {
	if(!newContent) {
		cerr << "Error in file " << __FILE__ << " at line " << __LINE__ << ":" << endl <<
		"Content points to NULL!" << endl;
	}
	if(find(contents->begin(), contents->end(), newContent) != contents->end()) {
		cerr << "Error in file " << __FILE__ << " at line " << __LINE__ << ":" << endl <<
			"Content already exists in content base" << endl;
	}
	/*if(contentsByAddress->find(newContent->address) != contentsByAddress->end()) {
		cerr << "Error in file " << __FILE__ << " at line " << __LINE__ << ":" << endl <<
		"Content address is already mapped in project database" << endl;
		return 0;
		}*/
	(*contentsByAddress)[newContent->address] = newContent;
	(*contentsByName)[newContent->name] = newContent;
	
	contents->push_back(newContent);
	return 1;	
}
string Project::getId() {
  string newName = "::Image";
  newName += currentId;
  currentId++;
  return newName;
}

int Project::removeContent(Content* content) {
  vector<Content*>::iterator i = find(contents->begin(), contents->end(), content);
  if(i == contents->end()) {
    cout << "Cant find the element to remve" << endl;
    return -1;
  }
  
  contents->erase(i);

  for(map<string, Content*>::iterator it = contentsByName->begin(); it != contentsByName->end(); it++) {
    if(it->second == content) {
      contentsByName->erase(it);
      break;
    }
  }

  for(map<string, Content*>::iterator it = contentsByAddress->begin(); it != contentsByAddress->end(); it++) {
    if(it->second == content) {
      contentsByAddress->erase(it);
      break;
    }
  }

  for(map<unsigned long, Content*>::iterator it = contentsById->begin(); it != contentsById->end(); it++) {
    if(it->second == content) {
      contentsById->erase(it);
      break;
    }
  }
  
  return 1;
}

vector<Content*>* Project::getUnsavedContents() {
  vector<Content*>* result = new vector<Content*>;
  for(unsigned int i = 0; i < contents->size(); i++) {
    if((*contents)[i]->address == "INMEM") {
      result->push_back((*contents)[i]);
    }
    else if((*contents)[i]->modified) {
      result->push_back((*contents)[i]);
    }
  }
  return result;
}
