#ifndef __PROJECT_H__
#define __PROJECT_H__

#include "wx/image.h"

#include <vector>
#include <map>

#include "content.h"
#include "meta.h"

using namespace std;

class Project
{
  friend class ProjectPresenter;
private:
  Meta* projectData;
  map<string, Content*>* contentsByName;
  map<unsigned long, Content*>* contentsById;
  map<string, Content*>* contentsByAddress;
  vector<Content*>* contents;
  
public:
  string address;
  static int currentId;
  Project() {
    currentId = 0;
    contents = new vector<Content*>;
    contentsByAddress = new map<string, Content*>;
    contentsById = new map<unsigned long, Content*>;
    contentsByName = new map<string, Content*>;
  }
  ~Project() {
    unsigned int contentSize = contents->size();
    for(unsigned int i = 0; i < contentSize; i++) {
      cout << "Deleting content #" << i << endl;
      //delete (*contents)[i];    
    }
    delete contents;
    delete contentsByName;
    delete contentsByAddress;
  }
  int addContent(Content*);
  //PartialImageContent* getContentByAddress(string address);
  vector<Content*>* getContents() {
    return contents;
  }
  int removeContent(Content*);

  void setMetaData(Meta* metaData) {
    projectData = new Meta(*metaData);
  }
  Meta* getMetaData() {
    return projectData;
  }
  string getName() {
    return projectData->getName();
  }
  vector<Content*>* getUnsavedContents();

  static string getId();
};
#endif
