#ifndef _PROJECTFACTORY_H_
#define _PROJECTFACTORY_H_

#include "globals.h"

#include <iostream>

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/dom/DOM.hpp>
#include <xercesc/parsers/XercesDOMParser.hpp>
#include <xercesc/sax/HandlerBase.hpp>
#include <xercesc/util/XMLString.hpp>

#include "project.h"
#include "content.h"

using namespace std;
XERCES_CPP_NAMESPACE_USE

class ProjectSerializer {
private:
	bool initXMLParser();
	static XercesDOMParser* getProjectDOM(string);
	static Project* getProject(xercesDOMDocument*);
	static Content* parseContentNode(DOMNode*);
	static Meta* parseMetaNode(DOMNode*);
	static Camera* parseCameraNode(DOMNode*);
	static void normalizeImageAddresses(Project*);
	static Project* loadProject(string projectPath);
	static Dem* loadDem(string, string, string);
	static int createMetaNode(DOMDocument*, DOMElement*, Meta*);
	static int createContentNode(DOMDocument*, DOMElement*, Content* );
	static int serializeDOMToFile(string, DOMNode*);
	static int saveProject(Project* project, string projectPath);
public:
	static Project* deserializeProject(string projectPath);
	static int serializeProject(Project* project, string projectPath);
	ProjectSerializer() {
	}

	static int serializeOrthophoto(Orthophoto*);
};
#endif
